/*
 * XetPan: a libEtPan! based Mail User Agent
 * Copyright (C) 2002-2003 Melvin Hadasht
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef GTK_FOLDERSVIEW_H
#define GTK_FOLDERSVIEW_H

#include <carray.h>
#include <gtk/gtkwidget.h>
#include <gdk/gdkevents.h> /* GDK_BUTTON_PRESS */

#include "folder-types.h"
#include "foldersview.h"

typedef struct XePGtkFoldersView_s XePGtkFoldersView;

typedef void (*XePGtkFoldersViewActivateCb)(XePGtkFoldersView *fview, 
					    gpointer data);

typedef gboolean (*XePGtkFoldersViewButtonCb)(XePGtkFoldersView *fview,
					      GdkEventButton *event,
					      gpointer data);

typedef gboolean (*XePFolderSelectionCb) (void *data, 
					  int response, 
					  carray *folder_refs);

XePGtkFoldersView *
a_GtkFoldersview_new(GtkSelectionMode mode);

void
a_GtkFoldersview_free(XePGtkFoldersView *fview);

#define XEP_GTK_FOLDERSVIEW_WIDGET(fview) (a_GtkFoldersview_widget(fview))

GtkWidget *
a_GtkFoldersview_widget(XePGtkFoldersView *fview);

void
a_GtkFoldersview_set_activate_callback(XePGtkFoldersView *fview,
				       XePGtkFoldersViewActivateCb user_cb,
				       gpointer user_data);
void
a_GtkFoldersview_set_button_release_callback(XePGtkFoldersView *fview,
					     XePGtkFoldersViewButtonCb user_cb,
					     gpointer user_data);
void
a_GtkFoldersview_set_list(XePGtkFoldersView *fview,
			  XePFoldersViewsList *foldersviewslist);

void
a_GtkFoldersview_set_view(XePGtkFoldersView *fview,
			  const char *foldersview_id);

XePFolderRef *
a_GtkFoldersview_get_selected(XePGtkFoldersView *fview);

carray *
a_GtkFoldersview_get_selected_rows(XePGtkFoldersView *fview);

void
a_GtkFoldersview_list_refresh(XePGtkFoldersView *fview);

void
a_GtkFoldersview_list_updated(XePGtkFoldersView *fview);

GtkWidget *
a_GtkFoldersview_folder_selection(GtkWidget *toplevel, 
				  const gchar *title,
				  const gchar *help,
				  XePFoldersViewsList *foldersviewslist,
				  XePFolderSelectionCb user_cb,
				  void *user_data);

#endif
